package com.zanxiang.common.utils;

import com.zanxiang.common.constant.Constants;
import lombok.extern.slf4j.Slf4j;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.util.*;

/**
 * @author xufeng
 * @date 2022/7/21 19:35
 */
@Slf4j
public class GameSignUtil {
    protected static final Logger logger = LoggerFactory.getLogger(GameSignUtil.class);

    /**
     * 验证sign
     *
     * @param param  参数
     * @param appKey 密钥
     * @return
     */
    public static Boolean verify(SortedMap<String, String> param, String appKey) {
        if (param.isEmpty() || param.get("sign").isEmpty()) {
            return false;
        }
        if (sign(param, appKey).equals(param.get("sign"))) {
            return true;
        }
        return false;
    }

    /**
     * 生成密钥
     *
     * @param param  参数
     * @param appKey 密钥
     * @return
     */
    public static String sign(SortedMap<String, String> param, String appKey) {
        StringBuffer sb = new StringBuffer();
        Set es = param.entrySet();
        Iterator it = es.iterator();
        while (it.hasNext()) {
            Map.Entry entry = (Map.Entry) it.next();
            String k = (String) entry.getKey();
            String v = entry.getValue() == null ? "" : (String) entry.getValue();
            if (null != v && !"".equals(v) && !"sign".equals(k)) {
                sb.append(k + "=" + v + "&");
            }
        }
        sb.append("appKey=" + appKey);
        String sign = MD5Util.MD5Encode(sb.toString(), Constants.UTF8).toUpperCase();
        logger.info("param:{}, appKey:{}, sign:{}, 加密原始串:{}", param, appKey, sign, sb);
        return sign;
    }
}
